import { h as D, resolveComponent as ve, openBlock as J, createElementBlock as U, normalizeClass as $, createElementVNode as z, renderSlot as ge, createTextVNode as pe, toDisplayString as de, createCommentVNode as X, createVNode as Q, defineComponent as me, computed as ye, unref as W } from "vue";
function Z(d) {
  "@babel/helpers - typeof";
  return Z = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(s) {
    return typeof s;
  } : function(s) {
    return s && typeof Symbol == "function" && s.constructor === Symbol && s !== Symbol.prototype ? "symbol" : typeof s;
  }, Z(d);
}
var be = /^([hH][tT]{2}[pP]:\/\/|[hH][tT]{2}[pP][sS]:\/\/)(([A-Za-z0-9-~]+)\.)+([A-Za-z0-9-~\/])+$/, q = {
  name: "JsonString",
  props: {
    jsonValue: {
      type: String,
      required: !0
    }
  },
  data: function() {
    return {
      expand: !0,
      canExtend: !1
    };
  },
  mounted: function() {
    this.$refs.itemRef.offsetHeight > this.$refs.holderRef.offsetHeight && (this.canExtend = !0);
  },
  methods: {
    toggle: function() {
      this.expand = !this.expand;
    }
  },
  render: function() {
    var s = this.jsonValue, c = be.test(s), g;
    return this.expand ? (g = {
      class: {
        "jv-item": !0,
        "jv-string": !0
      },
      ref: "itemRef"
    }, c ? (s = '<a href="'.concat(s, '" target="_blank" class="jv-link">').concat(s, "</a>"), g.innerHTML = '"'.concat(s.toString(), '"')) : g.innerText = '"'.concat(s.toString(), '"')) : g = {
      class: { "jv-ellipsis": !0 },
      onClick: this.toggle,
      innerText: "..."
    }, D("span", {}, [
      this.canExtend && D("span", {
        class: {
          "jv-toggle": !0,
          open: this.expand
        },
        onClick: this.toggle
      }),
      D("span", {
        class: { "jv-holder-node": !0 },
        ref: "holderRef"
      }),
      D("span", g)
    ]);
  }
};
q.__file = "src/Components/types/json-string.vue";
var x = {
  name: "JsonUndefined",
  functional: !0,
  props: {
    jsonValue: {
      type: Object,
      default: null
    }
  },
  render: function() {
    return D("span", {
      class: {
        "jv-item": !0,
        "jv-undefined": !0
      },
      innerText: this.jsonValue === null ? "null" : "undefined"
    });
  }
};
x.__file = "src/Components/types/json-undefined.vue";
var ee = {
  name: "JsonNumber",
  functional: !0,
  props: {
    jsonValue: {
      type: Number,
      required: !0
    }
  },
  render: function() {
    var s = Number.isInteger(this.jsonValue);
    return D("span", {
      class: {
        "jv-item": !0,
        "jv-number": !0,
        "jv-number-integer": s,
        "jv-number-float": !s
      },
      innerText: this.jsonValue.toString()
    });
  }
};
ee.__file = "src/Components/types/json-number.vue";
var te = {
  name: "JsonBoolean",
  functional: !0,
  props: { jsonValue: Boolean },
  render: function() {
    return D("span", {
      class: {
        "jv-item": !0,
        "jv-boolean": !0
      },
      innerText: this.jsonValue.toString()
    });
  }
};
te.__file = "src/Components/types/json-boolean.vue";
var ne = {
  name: "JsonObject",
  props: {
    jsonValue: {
      type: Object,
      required: !0
    },
    keyName: {
      type: String,
      default: ""
    },
    depth: {
      type: Number,
      default: 0
    },
    expand: Boolean,
    sort: Boolean,
    previewMode: Boolean
  },
  data: function() {
    return { value: {} };
  },
  computed: {
    ordered: function() {
      var s = this;
      if (!this.sort)
        return this.value;
      var c = {};
      return Object.keys(this.value).sort().forEach(function(g) {
        c[g] = s.value[g];
      }), c;
    }
  },
  watch: {
    jsonValue: function(s) {
      this.setValue(s);
    }
  },
  mounted: function() {
    this.setValue(this.jsonValue);
  },
  methods: {
    setValue: function(s) {
      var c = this;
      setTimeout(function() {
        c.value = s;
      }, 0);
    },
    toggle: function() {
      this.$emit("update:expand", !this.expand), this.dispatchEvent();
    },
    dispatchEvent: function() {
      try {
        this.$el.dispatchEvent(new Event("resized"));
      } catch {
        var s = document.createEvent("Event");
        s.initEvent("resized", !0, !1), this.$el.dispatchEvent(s);
      }
    }
  },
  render: function() {
    var s = [];
    if (!this.previewMode && !this.keyName && s.push(D("span", {
      class: {
        "jv-toggle": !0,
        open: !!this.expand
      },
      onClick: this.toggle
    })), s.push(D("span", {
      class: {
        "jv-item": !0,
        "jv-object": !0
      },
      innerText: "{"
    })), this.expand) {
      for (var c in this.ordered)
        if (this.ordered.hasOwnProperty(c)) {
          var g = this.ordered[c];
          s.push(D(G, {
            key: c,
            style: { display: this.expand ? void 0 : "none" },
            sort: this.sort,
            keyName: c,
            depth: this.depth + 1,
            value: g,
            previewMode: this.previewMode
          }));
        }
    }
    return !this.expand && Object.keys(this.value).length && s.push(D("span", {
      style: { display: this.expand ? "none" : void 0 },
      class: { "jv-ellipsis": !0 },
      onClick: this.toggle,
      title: "click to reveal object content (keys: ".concat(Object.keys(this.ordered).join(", "), ")"),
      innerText: "..."
    })), s.push(D("span", {
      class: {
        "jv-item": !0,
        "jv-object": !0
      },
      innerText: "}"
    })), D("span", s);
  }
};
ne.__file = "src/Components/types/json-object.vue";
var re = {
  name: "JsonArray",
  props: {
    jsonValue: {
      type: Array,
      required: !0
    },
    keyName: {
      type: String,
      default: ""
    },
    depth: {
      type: Number,
      default: 0
    },
    sort: Boolean,
    expand: Boolean,
    previewMode: Boolean
  },
  data: function() {
    return { value: [] };
  },
  watch: {
    jsonValue: function(s) {
      this.setValue(s);
    }
  },
  mounted: function() {
    this.setValue(this.jsonValue);
  },
  methods: {
    setValue: function(s) {
      var c = this, g = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
      g === 0 && (this.value = []), setTimeout(function() {
        s.length > g && (c.value.push(s[g]), c.setValue(s, g + 1));
      }, 0);
    },
    toggle: function() {
      this.$emit("update:expand", !this.expand);
      try {
        this.$el.dispatchEvent(new Event("resized"));
      } catch {
        var s = document.createEvent("Event");
        s.initEvent("resized", !0, !1), this.$el.dispatchEvent(s);
      }
    }
  },
  render: function() {
    var s = this, c = [];
    return !this.previewMode && !this.keyName && c.push(D("span", {
      class: {
        "jv-toggle": !0,
        open: !!this.expand
      },
      onClick: this.toggle
    })), c.push(D("span", {
      class: {
        "jv-item": !0,
        "jv-array": !0
      },
      innerText: "["
    })), this.expand && this.value.forEach(function(g, p) {
      c.push(D(G, {
        key: p,
        style: { display: s.expand ? void 0 : "none" },
        sort: s.sort,
        depth: s.depth + 1,
        value: g,
        previewMode: s.previewMode
      }));
    }), !this.expand && this.value.length && c.push(D("span", {
      style: { display: void 0 },
      class: { "jv-ellipsis": !0 },
      onClick: this.toggle,
      title: "click to reveal ".concat(this.value.length, " hidden items"),
      innerText: "..."
    })), c.push(D("span", {
      class: {
        "jv-item": !0,
        "jv-array": !0
      },
      innerText: "]"
    })), D("span", c);
  }
};
re.__file = "src/Components/types/json-array.vue";
var ie = {
  name: "JsonFunction",
  functional: !0,
  props: {
    jsonValue: {
      type: Function,
      required: !0
    }
  },
  render: function() {
    return D("span", {
      class: {
        "jv-item": !0,
        "jv-function": !0
      },
      attrs: { title: this.jsonValue.toString() },
      innerHTML: "&lt;function&gt;"
    });
  }
};
ie.__file = "src/Components/types/json-function.vue";
var ae = {
  name: "JsonDate",
  inject: ["timeformat"],
  functional: !0,
  props: {
    jsonValue: {
      type: Date,
      required: !0
    }
  },
  render: function() {
    var s = this.jsonValue, c = this.timeformat;
    return D("span", {
      class: {
        "jv-item": !0,
        "jv-string": !0
      },
      innerText: '"'.concat(c(s), '"')
    });
  }
};
ae.__file = "src/Components/types/json-date.vue";
var _e = /^([hH][tT]{2}[pP]:\/\/|[hH][tT]{2}[pP][sS]:\/\/)(([A-Za-z0-9-~]+)\.)+([A-Za-z0-9-~\/])+$/, se = {
  name: "JsonString",
  props: {
    jsonValue: {
      type: RegExp,
      required: !0
    }
  },
  data: function() {
    return {
      expand: !0,
      canExtend: !1
    };
  },
  mounted: function() {
    this.$refs.itemRef.offsetHeight > this.$refs.holderRef.offsetHeight && (this.canExtend = !0);
  },
  methods: {
    toggle: function() {
      this.expand = !this.expand;
    }
  },
  render: function() {
    var s = this.jsonValue, c = _e.test(s), g;
    return this.expand ? (g = {
      class: {
        "jv-item": !0,
        "jv-string": !0
      },
      ref: "itemRef"
    }, c ? (s = '<a href="'.concat(s, '" target="_blank" class="jv-link">').concat(s, "</a>"), g.innerHTML = "".concat(s.toString())) : g.innerText = "".concat(s.toString())) : g = {
      class: { "jv-ellipsis": !0 },
      onClick: this.toggle,
      innerText: "..."
    }, D("span", {}, [
      this.canExtend && D("span", {
        class: {
          "jv-toggle": !0,
          open: this.expand
        },
        onClick: this.toggle
      }),
      D("span", {
        class: { "jv-holder-node": !0 },
        ref: "holderRef"
      }),
      D("span", g)
    ]);
  }
};
se.__file = "src/Components/types/json-regexp.vue";
var G = {
  name: "JsonBox",
  inject: [
    "expandDepth",
    "keyClick"
  ],
  props: {
    value: {
      type: [
        Object,
        Array,
        String,
        Number,
        Boolean,
        Function,
        Date
      ],
      default: null
    },
    keyName: {
      type: String,
      default: ""
    },
    sort: Boolean,
    depth: {
      type: Number,
      default: 0
    },
    previewMode: Boolean
  },
  data: function() {
    return { expand: !0 };
  },
  mounted: function() {
    this.expand = this.previewMode || !(this.depth >= this.expandDepth);
  },
  methods: {
    toggle: function() {
      this.expand = !this.expand;
      try {
        this.$el.dispatchEvent(new Event("resized"));
      } catch {
        var s = document.createEvent("Event");
        s.initEvent("resized", !0, !1), this.$el.dispatchEvent(s);
      }
    }
  },
  render: function() {
    var s = this, c = [], g;
    this.value === null || this.value === void 0 ? g = x : Array.isArray(this.value) ? g = re : Object.prototype.toString.call(this.value) === "[object Date]" ? g = ae : this.value.constructor === RegExp ? g = se : Z(this.value) === "object" ? g = ne : typeof this.value == "number" ? g = ee : typeof this.value == "string" ? g = q : typeof this.value == "boolean" ? g = te : typeof this.value == "function" && (g = ie);
    var p = this.keyName && this.value && (Array.isArray(this.value) || Z(this.value) === "object" && Object.prototype.toString.call(this.value) !== "[object Date]");
    return !this.previewMode && p && c.push(D("span", {
      class: {
        "jv-toggle": !0,
        open: !!this.expand
      },
      onClick: this.toggle
    })), this.keyName && c.push(D("span", {
      class: { "jv-key": !0 },
      onClick: function() {
        s.keyClick(s.keyName);
      },
      innerText: "".concat(this.keyName, ":")
    })), c.push(D(g, {
      class: { "jv-push": !0 },
      jsonValue: this.value,
      keyName: this.keyName,
      sort: this.sort,
      depth: this.depth,
      expand: this.expand,
      previewMode: this.previewMode,
      "onUpdate:expand": function(t) {
        s.expand = t;
      }
    })), D("div", {
      class: {
        "jv-node": !0,
        "jv-key-node": !!this.keyName && !p,
        toggle: !this.previewMode && p
      }
    }, c);
  }
};
G.__file = "src/Components/json-box.vue";
var we = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function je(d) {
  return d && d.__esModule && Object.prototype.hasOwnProperty.call(d, "default") ? d.default : d;
}
var oe = { exports: {} };
(function(d, s) {
  (function(g, p) {
    d.exports = p();
  })(we, function() {
    return function() {
      var c = {
        686: function(e, t, n) {
          n.d(t, {
            default: function() {
              return ce;
            }
          });
          var a = n(279), i = n.n(a), r = n(370), o = n.n(r), l = n(817), u = n.n(l);
          function f(E) {
            try {
              return document.execCommand(E);
            } catch {
              return !1;
            }
          }
          var h = function(b) {
            var y = u()(b);
            return f("cut"), y;
          }, v = h;
          function m(E) {
            var b = document.documentElement.getAttribute("dir") === "rtl", y = document.createElement("textarea");
            y.style.fontSize = "12pt", y.style.border = "0", y.style.padding = "0", y.style.margin = "0", y.style.position = "absolute", y.style[b ? "right" : "left"] = "-9999px";
            var M = window.pageYOffset || document.documentElement.scrollTop;
            return y.style.top = "".concat(M, "px"), y.setAttribute("readonly", ""), y.value = E, y;
          }
          var _ = function(b) {
            var y = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : { container: document.body }, M = "";
            if (typeof b == "string") {
              var w = m(b);
              y.container.appendChild(w), M = u()(w), f("copy"), w.remove();
            } else
              M = u()(b), f("copy");
            return M;
          }, j = _;
          function T(E) {
            "@babel/helpers - typeof";
            return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? T = function(y) {
              return typeof y;
            } : T = function(y) {
              return y && typeof Symbol == "function" && y.constructor === Symbol && y !== Symbol.prototype ? "symbol" : typeof y;
            }, T(E);
          }
          var O = function() {
            var b = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, y = b.action, M = y === void 0 ? "copy" : y, w = b.container, S = b.target, L = b.text;
            if (M !== "copy" && M !== "cut")
              throw new Error('Invalid "action" value, use either "copy" or "cut"');
            if (S !== void 0)
              if (S && T(S) === "object" && S.nodeType === 1) {
                if (M === "copy" && S.hasAttribute("disabled"))
                  throw new Error('Invalid "target" attribute. Please use "readonly" instead of "disabled" attribute');
                if (M === "cut" && (S.hasAttribute("readonly") || S.hasAttribute("disabled")))
                  throw new Error(`Invalid "target" attribute. You can't cut text from elements with "readonly" or "disabled" attributes`);
              } else
                throw new Error('Invalid "target" value, use a valid Element');
            if (L)
              return j(L, { container: w });
            if (S)
              return M === "cut" ? v(S) : j(S, { container: w });
          }, k = O;
          function C(E) {
            "@babel/helpers - typeof";
            return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? C = function(y) {
              return typeof y;
            } : C = function(y) {
              return y && typeof Symbol == "function" && y.constructor === Symbol && y !== Symbol.prototype ? "symbol" : typeof y;
            }, C(E);
          }
          function N(E, b) {
            if (!(E instanceof b))
              throw new TypeError("Cannot call a class as a function");
          }
          function A(E, b) {
            for (var y = 0; y < b.length; y++) {
              var M = b[y];
              M.enumerable = M.enumerable || !1, M.configurable = !0, "value" in M && (M.writable = !0), Object.defineProperty(E, M.key, M);
            }
          }
          function V(E, b, y) {
            return b && A(E.prototype, b), y && A(E, y), E;
          }
          function P(E, b) {
            if (typeof b != "function" && b !== null)
              throw new TypeError("Super expression must either be null or a function");
            E.prototype = Object.create(b && b.prototype, {
              constructor: {
                value: E,
                writable: !0,
                configurable: !0
              }
            }), b && R(E, b);
          }
          function R(E, b) {
            return R = Object.setPrototypeOf || function(M, w) {
              return M.__proto__ = w, M;
            }, R(E, b);
          }
          function I(E) {
            var b = fe();
            return function() {
              var M = F(E), w;
              if (b) {
                var S = F(this).constructor;
                w = Reflect.construct(M, arguments, S);
              } else
                w = M.apply(this, arguments);
              return B(this, w);
            };
          }
          function B(E, b) {
            return b && (C(b) === "object" || typeof b == "function") ? b : ue(E);
          }
          function ue(E) {
            if (E === void 0)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return E;
          }
          function fe() {
            if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
              return !1;
            if (typeof Proxy == "function")
              return !0;
            try {
              return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
              })), !0;
            } catch {
              return !1;
            }
          }
          function F(E) {
            return F = Object.setPrototypeOf ? Object.getPrototypeOf : function(y) {
              return y.__proto__ || Object.getPrototypeOf(y);
            }, F(E);
          }
          function Y(E, b) {
            var y = "data-clipboard-".concat(E);
            if (b.hasAttribute(y))
              return b.getAttribute(y);
          }
          var he = function(E) {
            P(y, E);
            var b = I(y);
            function y(M, w) {
              var S;
              return N(this, y), S = b.call(this), S.resolveOptions(w), S.listenClick(M), S;
            }
            return V(y, [
              {
                key: "resolveOptions",
                value: function() {
                  var w = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
                  this.action = typeof w.action == "function" ? w.action : this.defaultAction, this.target = typeof w.target == "function" ? w.target : this.defaultTarget, this.text = typeof w.text == "function" ? w.text : this.defaultText, this.container = C(w.container) === "object" ? w.container : document.body;
                }
              },
              {
                key: "listenClick",
                value: function(w) {
                  var S = this;
                  this.listener = o()(w, "click", function(L) {
                    return S.onClick(L);
                  });
                }
              },
              {
                key: "onClick",
                value: function(w) {
                  var S = w.delegateTarget || w.currentTarget, L = this.action(S) || "copy", H = k({
                    action: L,
                    container: this.container,
                    target: this.target(S),
                    text: this.text(S)
                  });
                  this.emit(H ? "success" : "error", {
                    action: L,
                    text: H,
                    trigger: S,
                    clearSelection: function() {
                      S && S.focus(), document.activeElement.blur(), window.getSelection().removeAllRanges();
                    }
                  });
                }
              },
              {
                key: "defaultAction",
                value: function(w) {
                  return Y("action", w);
                }
              },
              {
                key: "defaultTarget",
                value: function(w) {
                  var S = Y("target", w);
                  if (S)
                    return document.querySelector(S);
                }
              },
              {
                key: "defaultText",
                value: function(w) {
                  return Y("text", w);
                }
              },
              {
                key: "destroy",
                value: function() {
                  this.listener.destroy();
                }
              }
            ], [
              {
                key: "copy",
                value: function(w) {
                  var S = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : { container: document.body };
                  return j(w, S);
                }
              },
              {
                key: "cut",
                value: function(w) {
                  return v(w);
                }
              },
              {
                key: "isSupported",
                value: function() {
                  var w = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [
                    "copy",
                    "cut"
                  ], S = typeof w == "string" ? [w] : w, L = !!document.queryCommandSupported;
                  return S.forEach(function(H) {
                    L = L && !!document.queryCommandSupported(H);
                  }), L;
                }
              }
            ]), y;
          }(i()), ce = he;
        },
        828: function(e) {
          var t = 9;
          if (typeof Element < "u" && !Element.prototype.matches) {
            var n = Element.prototype;
            n.matches = n.matchesSelector || n.mozMatchesSelector || n.msMatchesSelector || n.oMatchesSelector || n.webkitMatchesSelector;
          }
          function a(i, r) {
            for (; i && i.nodeType !== t; ) {
              if (typeof i.matches == "function" && i.matches(r))
                return i;
              i = i.parentNode;
            }
          }
          e.exports = a;
        },
        438: function(e, t, n) {
          var a = n(828);
          function i(l, u, f, h, v) {
            var m = o.apply(this, arguments);
            return l.addEventListener(f, m, v), {
              destroy: function() {
                l.removeEventListener(f, m, v);
              }
            };
          }
          function r(l, u, f, h, v) {
            return typeof l.addEventListener == "function" ? i.apply(null, arguments) : typeof f == "function" ? i.bind(null, document).apply(null, arguments) : (typeof l == "string" && (l = document.querySelectorAll(l)), Array.prototype.map.call(l, function(m) {
              return i(m, u, f, h, v);
            }));
          }
          function o(l, u, f, h) {
            return function(v) {
              v.delegateTarget = a(v.target, u), v.delegateTarget && h.call(l, v);
            };
          }
          e.exports = r;
        },
        879: function(e, t) {
          t.node = function(n) {
            return n !== void 0 && n instanceof HTMLElement && n.nodeType === 1;
          }, t.nodeList = function(n) {
            var a = Object.prototype.toString.call(n);
            return n !== void 0 && (a === "[object NodeList]" || a === "[object HTMLCollection]") && "length" in n && (n.length === 0 || t.node(n[0]));
          }, t.string = function(n) {
            return typeof n == "string" || n instanceof String;
          }, t.fn = function(n) {
            var a = Object.prototype.toString.call(n);
            return a === "[object Function]";
          };
        },
        370: function(e, t, n) {
          var a = n(879), i = n(438);
          function r(f, h, v) {
            if (!f && !h && !v)
              throw new Error("Missing required arguments");
            if (!a.string(h))
              throw new TypeError("Second argument must be a String");
            if (!a.fn(v))
              throw new TypeError("Third argument must be a Function");
            if (a.node(f))
              return o(f, h, v);
            if (a.nodeList(f))
              return l(f, h, v);
            if (a.string(f))
              return u(f, h, v);
            throw new TypeError("First argument must be a String, HTMLElement, HTMLCollection, or NodeList");
          }
          function o(f, h, v) {
            return f.addEventListener(h, v), {
              destroy: function() {
                f.removeEventListener(h, v);
              }
            };
          }
          function l(f, h, v) {
            return Array.prototype.forEach.call(f, function(m) {
              m.addEventListener(h, v);
            }), {
              destroy: function() {
                Array.prototype.forEach.call(f, function(m) {
                  m.removeEventListener(h, v);
                });
              }
            };
          }
          function u(f, h, v) {
            return i(document.body, f, h, v);
          }
          e.exports = r;
        },
        817: function(e) {
          function t(n) {
            var a;
            if (n.nodeName === "SELECT")
              n.focus(), a = n.value;
            else if (n.nodeName === "INPUT" || n.nodeName === "TEXTAREA") {
              var i = n.hasAttribute("readonly");
              i || n.setAttribute("readonly", ""), n.select(), n.setSelectionRange(0, n.value.length), i || n.removeAttribute("readonly"), a = n.value;
            } else {
              n.hasAttribute("contenteditable") && n.focus();
              var r = window.getSelection(), o = document.createRange();
              o.selectNodeContents(n), r.removeAllRanges(), r.addRange(o), a = r.toString();
            }
            return a;
          }
          e.exports = t;
        },
        279: function(e) {
          function t() {
          }
          t.prototype = {
            on: function(n, a, i) {
              var r = this.e || (this.e = {});
              return (r[n] || (r[n] = [])).push({
                fn: a,
                ctx: i
              }), this;
            },
            once: function(n, a, i) {
              var r = this;
              function o() {
                r.off(n, o), a.apply(i, arguments);
              }
              return o._ = a, this.on(n, o, i);
            },
            emit: function(n) {
              var a = [].slice.call(arguments, 1), i = ((this.e || (this.e = {}))[n] || []).slice(), r = 0, o = i.length;
              for (r; r < o; r++)
                i[r].fn.apply(i[r].ctx, a);
              return this;
            },
            off: function(n, a) {
              var i = this.e || (this.e = {}), r = i[n], o = [];
              if (r && a)
                for (var l = 0, u = r.length; l < u; l++)
                  r[l].fn !== a && r[l].fn._ !== a && o.push(r[l]);
              return o.length ? i[n] = o : delete i[n], this;
            }
          }, e.exports = t, e.exports.TinyEmitter = t;
        }
      }, g = {};
      function p(e) {
        if (g[e])
          return g[e].exports;
        var t = g[e] = { exports: {} };
        return c[e](t, t.exports, p), t.exports;
      }
      return function() {
        p.n = function(e) {
          var t = e && e.__esModule ? function() {
            return e.default;
          } : function() {
            return e;
          };
          return p.d(t, { a: t }), t;
        };
      }(), function() {
        p.d = function(e, t) {
          for (var n in t)
            p.o(t, n) && !p.o(e, n) && Object.defineProperty(e, n, {
              enumerable: !0,
              get: t[n]
            });
        };
      }(), function() {
        p.o = function(e, t) {
          return Object.prototype.hasOwnProperty.call(e, t);
        };
      }(), p(686);
    }().default;
  });
})(oe);
var Ee = je(oe.exports), Me = function(s, c) {
  var g = Date.now(), p;
  return function() {
    for (var e = arguments.length, t = new Array(e), n = 0; n < e; n++)
      t[n] = arguments[n];
    Date.now() - g < c && p && clearTimeout(p), p = setTimeout(function() {
      s.apply(void 0, t);
    }, c), g = Date.now();
  };
}, K = {
  name: "JsonViewer",
  components: { JsonBox: G },
  props: {
    value: {
      type: [
        Object,
        Array,
        String,
        Number,
        Boolean,
        Function
      ],
      required: !0
    },
    expanded: {
      type: Boolean,
      default: !1
    },
    expandDepth: {
      type: Number,
      default: 1
    },
    copyable: {
      type: [
        Boolean,
        Object
      ],
      default: !1
    },
    sort: {
      type: Boolean,
      default: !1
    },
    boxed: {
      type: Boolean,
      default: !1
    },
    theme: {
      type: String,
      default: "light"
    },
    timeformat: {
      type: Function,
      default: function(s) {
        return s.toLocaleString();
      }
    },
    previewMode: {
      type: Boolean,
      default: !1
    }
  },
  provide: function() {
    return {
      expandDepth: this.expandDepth,
      timeformat: this.timeformat,
      keyClick: this.keyClick
    };
  },
  data: function() {
    return {
      copied: !1,
      expandableCode: !1,
      expandCode: this.expanded
    };
  },
  emits: ["onKeyClick"],
  computed: {
    jvClass: function() {
      return "jv-container jv-" + this.theme + (this.boxed ? " boxed" : "");
    },
    copyText: function() {
      var s = this.copyable, c = s.copyText, g = s.copiedText, p = s.timeout, e = s.align;
      return {
        copyText: c || "copy",
        copiedText: g || "copied!",
        timeout: p || 2e3,
        align: e
      };
    }
  },
  watch: {
    value: function() {
      this.onResized();
    }
  },
  mounted: function() {
    var s = this;
    if (this.debounceResized = Me(this.debResized.bind(this), 200), this.boxed && this.$refs.jsonBox && (this.onResized(), this.$refs.jsonBox.$el.addEventListener("resized", this.onResized, !0)), this.copyable) {
      var c = new Ee(this.$refs.clip, {
        text: function() {
          return JSON.stringify(s.value, null, 2);
        }
      });
      c.on("success", function(g) {
        s.onCopied(g);
      });
    }
  },
  methods: {
    onResized: function() {
      this.debounceResized();
    },
    debResized: function() {
      var s = this;
      this.$nextTick(function() {
        s.$refs.jsonBox && (s.$refs.jsonBox.$el.clientHeight >= 250 ? s.expandableCode = !0 : s.expandableCode = !1);
      });
    },
    keyClick: function(s) {
      this.$emit("onKeyClick", s);
    },
    onCopied: function(s) {
      var c = this;
      this.copied || (this.copied = !0, setTimeout(function() {
        c.copied = !1;
      }, this.copyText.timeout), this.$emit("copied", s));
    },
    toggleExpandCode: function() {
      this.expandCode = !this.expandCode;
    }
  }
};
function Te(d, s, c, g, p, e) {
  var t = ve("json-box");
  return J(), U("div", { class: $(e.jvClass) }, [
    c.copyable ? (J(), U("div", {
      key: 0,
      class: $("jv-tooltip ".concat(e.copyText.align || "right"))
    }, [z("span", {
      ref: "clip",
      class: $([
        "jv-button",
        { copied: p.copied }
      ])
    }, [ge(d.$slots, "copy", { copied: p.copied }, function() {
      return [pe(de(p.copied ? e.copyText.copiedText : e.copyText.copyText), 1)];
    })], 2)], 2)) : X("v-if", !0),
    z("div", {
      class: $([
        "jv-code",
        {
          open: p.expandCode,
          boxed: c.boxed
        }
      ])
    }, [Q(t, {
      ref: "jsonBox",
      value: c.value,
      sort: c.sort,
      "preview-mode": c.previewMode
    }, null, 8, [
      "value",
      "sort",
      "preview-mode"
    ])], 2),
    p.expandableCode && c.boxed ? (J(), U("div", {
      key: 1,
      class: "jv-more",
      onClick: s[0] || (s[0] = function() {
        return e.toggleExpandCode && e.toggleExpandCode.apply(e, arguments);
      })
    }, [z("span", {
      class: $([
        "jv-toggle",
        { open: !!p.expandCode }
      ])
    }, null, 2)])) : X("v-if", !0)
  ], 2);
}
K.render = Te;
K.__file = "src/Components/json-viewer.vue";
var le = { exports: {} };
(function(d) {
  var s = function() {
    this.Diff_Timeout = 1, this.Diff_EditCost = 4, this.Match_Threshold = 0.5, this.Match_Distance = 1e3, this.Patch_DeleteThreshold = 0.5, this.Patch_Margin = 4, this.Match_MaxBits = 32;
  }, c = -1, g = 1, p = 0;
  s.Diff = function(e, t) {
    return [e, t];
  }, s.prototype.diff_main = function(e, t, n, a) {
    typeof a > "u" && (this.Diff_Timeout <= 0 ? a = Number.MAX_VALUE : a = (/* @__PURE__ */ new Date()).getTime() + this.Diff_Timeout * 1e3);
    var i = a;
    if (e == null || t == null)
      throw new Error("Null input. (diff_main)");
    if (e == t)
      return e ? [new s.Diff(p, e)] : [];
    typeof n > "u" && (n = !0);
    var r = n, o = this.diff_commonPrefix(e, t), l = e.substring(0, o);
    e = e.substring(o), t = t.substring(o), o = this.diff_commonSuffix(e, t);
    var u = e.substring(e.length - o);
    e = e.substring(0, e.length - o), t = t.substring(0, t.length - o);
    var f = this.diff_compute_(e, t, r, i);
    return l && f.unshift(new s.Diff(p, l)), u && f.push(new s.Diff(p, u)), this.diff_cleanupMerge(f), f;
  }, s.prototype.diff_compute_ = function(e, t, n, a) {
    var i;
    if (!e)
      return [new s.Diff(g, t)];
    if (!t)
      return [new s.Diff(c, e)];
    var r = e.length > t.length ? e : t, o = e.length > t.length ? t : e, l = r.indexOf(o);
    if (l != -1)
      return i = [
        new s.Diff(g, r.substring(0, l)),
        new s.Diff(p, o),
        new s.Diff(
          g,
          r.substring(l + o.length)
        )
      ], e.length > t.length && (i[0][0] = i[2][0] = c), i;
    if (o.length == 1)
      return [
        new s.Diff(c, e),
        new s.Diff(g, t)
      ];
    var u = this.diff_halfMatch_(e, t);
    if (u) {
      var f = u[0], h = u[1], v = u[2], m = u[3], _ = u[4], j = this.diff_main(f, v, n, a), T = this.diff_main(h, m, n, a);
      return j.concat(
        [new s.Diff(p, _)],
        T
      );
    }
    return n && e.length > 100 && t.length > 100 ? this.diff_lineMode_(e, t, a) : this.diff_bisect_(e, t, a);
  }, s.prototype.diff_lineMode_ = function(e, t, n) {
    var a = this.diff_linesToChars_(e, t);
    e = a.chars1, t = a.chars2;
    var i = a.lineArray, r = this.diff_main(e, t, !1, n);
    this.diff_charsToLines_(r, i), this.diff_cleanupSemantic(r), r.push(new s.Diff(p, ""));
    for (var o = 0, l = 0, u = 0, f = "", h = ""; o < r.length; ) {
      switch (r[o][0]) {
        case g:
          u++, h += r[o][1];
          break;
        case c:
          l++, f += r[o][1];
          break;
        case p:
          if (l >= 1 && u >= 1) {
            r.splice(
              o - l - u,
              l + u
            ), o = o - l - u;
            for (var v = this.diff_main(f, h, !1, n), m = v.length - 1; m >= 0; m--)
              r.splice(o, 0, v[m]);
            o = o + v.length;
          }
          u = 0, l = 0, f = "", h = "";
          break;
      }
      o++;
    }
    return r.pop(), r;
  }, s.prototype.diff_bisect_ = function(e, t, n) {
    for (var a = e.length, i = t.length, r = Math.ceil((a + i) / 2), o = r, l = 2 * r, u = new Array(l), f = new Array(l), h = 0; h < l; h++)
      u[h] = -1, f[h] = -1;
    u[o + 1] = 0, f[o + 1] = 0;
    for (var v = a - i, m = v % 2 != 0, _ = 0, j = 0, T = 0, O = 0, k = 0; k < r && !((/* @__PURE__ */ new Date()).getTime() > n); k++) {
      for (var C = -k + _; C <= k - j; C += 2) {
        var N = o + C, A;
        C == -k || C != k && u[N - 1] < u[N + 1] ? A = u[N + 1] : A = u[N - 1] + 1;
        for (var V = A - C; A < a && V < i && e.charAt(A) == t.charAt(V); )
          A++, V++;
        if (u[N] = A, A > a)
          j += 2;
        else if (V > i)
          _ += 2;
        else if (m) {
          var P = o + v - C;
          if (P >= 0 && P < l && f[P] != -1) {
            var R = a - f[P];
            if (A >= R)
              return this.diff_bisectSplit_(e, t, A, V, n);
          }
        }
      }
      for (var I = -k + T; I <= k - O; I += 2) {
        var P = o + I, R;
        I == -k || I != k && f[P - 1] < f[P + 1] ? R = f[P + 1] : R = f[P - 1] + 1;
        for (var B = R - I; R < a && B < i && e.charAt(a - R - 1) == t.charAt(i - B - 1); )
          R++, B++;
        if (f[P] = R, R > a)
          O += 2;
        else if (B > i)
          T += 2;
        else if (!m) {
          var N = o + v - I;
          if (N >= 0 && N < l && u[N] != -1) {
            var A = u[N], V = o + A - N;
            if (R = a - R, A >= R)
              return this.diff_bisectSplit_(e, t, A, V, n);
          }
        }
      }
    }
    return [
      new s.Diff(c, e),
      new s.Diff(g, t)
    ];
  }, s.prototype.diff_bisectSplit_ = function(e, t, n, a, i) {
    var r = e.substring(0, n), o = t.substring(0, a), l = e.substring(n), u = t.substring(a), f = this.diff_main(r, o, !1, i), h = this.diff_main(l, u, !1, i);
    return f.concat(h);
  }, s.prototype.diff_linesToChars_ = function(e, t) {
    var n = [], a = {};
    n[0] = "";
    function i(u) {
      for (var f = "", h = 0, v = -1, m = n.length; v < u.length - 1; ) {
        v = u.indexOf(`
`, h), v == -1 && (v = u.length - 1);
        var _ = u.substring(h, v + 1);
        (a.hasOwnProperty ? a.hasOwnProperty(_) : a[_] !== void 0) ? f += String.fromCharCode(a[_]) : (m == r && (_ = u.substring(h), v = u.length), f += String.fromCharCode(m), a[_] = m, n[m++] = _), h = v + 1;
      }
      return f;
    }
    var r = 4e4, o = i(e);
    r = 65535;
    var l = i(t);
    return { chars1: o, chars2: l, lineArray: n };
  }, s.prototype.diff_charsToLines_ = function(e, t) {
    for (var n = 0; n < e.length; n++) {
      for (var a = e[n][1], i = [], r = 0; r < a.length; r++)
        i[r] = t[a.charCodeAt(r)];
      e[n][1] = i.join("");
    }
  }, s.prototype.diff_commonPrefix = function(e, t) {
    if (!e || !t || e.charAt(0) != t.charAt(0))
      return 0;
    for (var n = 0, a = Math.min(e.length, t.length), i = a, r = 0; n < i; )
      e.substring(r, i) == t.substring(r, i) ? (n = i, r = n) : a = i, i = Math.floor((a - n) / 2 + n);
    return i;
  }, s.prototype.diff_commonSuffix = function(e, t) {
    if (!e || !t || e.charAt(e.length - 1) != t.charAt(t.length - 1))
      return 0;
    for (var n = 0, a = Math.min(e.length, t.length), i = a, r = 0; n < i; )
      e.substring(e.length - i, e.length - r) == t.substring(t.length - i, t.length - r) ? (n = i, r = n) : a = i, i = Math.floor((a - n) / 2 + n);
    return i;
  }, s.prototype.diff_commonOverlap_ = function(e, t) {
    var n = e.length, a = t.length;
    if (n == 0 || a == 0)
      return 0;
    n > a ? e = e.substring(n - a) : n < a && (t = t.substring(0, n));
    var i = Math.min(n, a);
    if (e == t)
      return i;
    for (var r = 0, o = 1; ; ) {
      var l = e.substring(i - o), u = t.indexOf(l);
      if (u == -1)
        return r;
      o += u, (u == 0 || e.substring(i - o) == t.substring(0, o)) && (r = o, o++);
    }
  }, s.prototype.diff_halfMatch_ = function(e, t) {
    if (this.Diff_Timeout <= 0)
      return null;
    var n = e.length > t.length ? e : t, a = e.length > t.length ? t : e;
    if (n.length < 4 || a.length * 2 < n.length)
      return null;
    var i = this;
    function r(j, T, O) {
      for (var k = j.substring(O, O + Math.floor(j.length / 4)), C = -1, N = "", A, V, P, R; (C = T.indexOf(k, C + 1)) != -1; ) {
        var I = i.diff_commonPrefix(
          j.substring(O),
          T.substring(C)
        ), B = i.diff_commonSuffix(
          j.substring(0, O),
          T.substring(0, C)
        );
        N.length < B + I && (N = T.substring(C - B, C) + T.substring(C, C + I), A = j.substring(0, O - B), V = j.substring(O + I), P = T.substring(0, C - B), R = T.substring(C + I));
      }
      return N.length * 2 >= j.length ? [
        A,
        V,
        P,
        R,
        N
      ] : null;
    }
    var o = r(
      n,
      a,
      Math.ceil(n.length / 4)
    ), l = r(
      n,
      a,
      Math.ceil(n.length / 2)
    ), u;
    if (!o && !l)
      return null;
    l ? o ? u = o[4].length > l[4].length ? o : l : u = l : u = o;
    var f, h, v, m;
    e.length > t.length ? (f = u[0], h = u[1], v = u[2], m = u[3]) : (v = u[0], m = u[1], f = u[2], h = u[3]);
    var _ = u[4];
    return [f, h, v, m, _];
  }, s.prototype.diff_cleanupSemantic = function(e) {
    for (var t = !1, n = [], a = 0, i = null, r = 0, o = 0, l = 0, u = 0, f = 0; r < e.length; )
      e[r][0] == p ? (n[a++] = r, o = u, l = f, u = 0, f = 0, i = e[r][1]) : (e[r][0] == g ? u += e[r][1].length : f += e[r][1].length, i && i.length <= Math.max(o, l) && i.length <= Math.max(
        u,
        f
      ) && (e.splice(
        n[a - 1],
        0,
        new s.Diff(c, i)
      ), e[n[a - 1] + 1][0] = g, a--, a--, r = a > 0 ? n[a - 1] : -1, o = 0, l = 0, u = 0, f = 0, i = null, t = !0)), r++;
    for (t && this.diff_cleanupMerge(e), this.diff_cleanupSemanticLossless(e), r = 1; r < e.length; ) {
      if (e[r - 1][0] == c && e[r][0] == g) {
        var h = e[r - 1][1], v = e[r][1], m = this.diff_commonOverlap_(h, v), _ = this.diff_commonOverlap_(v, h);
        m >= _ ? (m >= h.length / 2 || m >= v.length / 2) && (e.splice(r, 0, new s.Diff(
          p,
          v.substring(0, m)
        )), e[r - 1][1] = h.substring(0, h.length - m), e[r + 1][1] = v.substring(m), r++) : (_ >= h.length / 2 || _ >= v.length / 2) && (e.splice(r, 0, new s.Diff(
          p,
          h.substring(0, _)
        )), e[r - 1][0] = g, e[r - 1][1] = v.substring(0, v.length - _), e[r + 1][0] = c, e[r + 1][1] = h.substring(_), r++), r++;
      }
      r++;
    }
  }, s.prototype.diff_cleanupSemanticLossless = function(e) {
    function t(_, j) {
      if (!_ || !j)
        return 6;
      var T = _.charAt(_.length - 1), O = j.charAt(0), k = T.match(s.nonAlphaNumericRegex_), C = O.match(s.nonAlphaNumericRegex_), N = k && T.match(s.whitespaceRegex_), A = C && O.match(s.whitespaceRegex_), V = N && T.match(s.linebreakRegex_), P = A && O.match(s.linebreakRegex_), R = V && _.match(s.blanklineEndRegex_), I = P && j.match(s.blanklineStartRegex_);
      return R || I ? 5 : V || P ? 4 : k && !N && A ? 3 : N || A ? 2 : k || C ? 1 : 0;
    }
    for (var n = 1; n < e.length - 1; ) {
      if (e[n - 1][0] == p && e[n + 1][0] == p) {
        var a = e[n - 1][1], i = e[n][1], r = e[n + 1][1], o = this.diff_commonSuffix(a, i);
        if (o) {
          var l = i.substring(i.length - o);
          a = a.substring(0, a.length - o), i = l + i.substring(0, i.length - o), r = l + r;
        }
        for (var u = a, f = i, h = r, v = t(a, i) + t(i, r); i.charAt(0) === r.charAt(0); ) {
          a += i.charAt(0), i = i.substring(1) + r.charAt(0), r = r.substring(1);
          var m = t(a, i) + t(i, r);
          m >= v && (v = m, u = a, f = i, h = r);
        }
        e[n - 1][1] != u && (u ? e[n - 1][1] = u : (e.splice(n - 1, 1), n--), e[n][1] = f, h ? e[n + 1][1] = h : (e.splice(n + 1, 1), n--));
      }
      n++;
    }
  }, s.nonAlphaNumericRegex_ = /[^a-zA-Z0-9]/, s.whitespaceRegex_ = /\s/, s.linebreakRegex_ = /[\r\n]/, s.blanklineEndRegex_ = /\n\r?\n$/, s.blanklineStartRegex_ = /^\r?\n\r?\n/, s.prototype.diff_cleanupEfficiency = function(e) {
    for (var t = !1, n = [], a = 0, i = null, r = 0, o = !1, l = !1, u = !1, f = !1; r < e.length; )
      e[r][0] == p ? (e[r][1].length < this.Diff_EditCost && (u || f) ? (n[a++] = r, o = u, l = f, i = e[r][1]) : (a = 0, i = null), u = f = !1) : (e[r][0] == c ? f = !0 : u = !0, i && (o && l && u && f || i.length < this.Diff_EditCost / 2 && o + l + u + f == 3) && (e.splice(
        n[a - 1],
        0,
        new s.Diff(c, i)
      ), e[n[a - 1] + 1][0] = g, a--, i = null, o && l ? (u = f = !0, a = 0) : (a--, r = a > 0 ? n[a - 1] : -1, u = f = !1), t = !0)), r++;
    t && this.diff_cleanupMerge(e);
  }, s.prototype.diff_cleanupMerge = function(e) {
    e.push(new s.Diff(p, ""));
    for (var t = 0, n = 0, a = 0, i = "", r = "", o; t < e.length; )
      switch (e[t][0]) {
        case g:
          a++, r += e[t][1], t++;
          break;
        case c:
          n++, i += e[t][1], t++;
          break;
        case p:
          n + a > 1 ? (n !== 0 && a !== 0 && (o = this.diff_commonPrefix(r, i), o !== 0 && (t - n - a > 0 && e[t - n - a - 1][0] == p ? e[t - n - a - 1][1] += r.substring(0, o) : (e.splice(0, 0, new s.Diff(
            p,
            r.substring(0, o)
          )), t++), r = r.substring(o), i = i.substring(o)), o = this.diff_commonSuffix(r, i), o !== 0 && (e[t][1] = r.substring(r.length - o) + e[t][1], r = r.substring(0, r.length - o), i = i.substring(0, i.length - o))), t -= n + a, e.splice(t, n + a), i.length && (e.splice(
            t,
            0,
            new s.Diff(c, i)
          ), t++), r.length && (e.splice(
            t,
            0,
            new s.Diff(g, r)
          ), t++), t++) : t !== 0 && e[t - 1][0] == p ? (e[t - 1][1] += e[t][1], e.splice(t, 1)) : t++, a = 0, n = 0, i = "", r = "";
          break;
      }
    e[e.length - 1][1] === "" && e.pop();
    var l = !1;
    for (t = 1; t < e.length - 1; )
      e[t - 1][0] == p && e[t + 1][0] == p && (e[t][1].substring(e[t][1].length - e[t - 1][1].length) == e[t - 1][1] ? (e[t][1] = e[t - 1][1] + e[t][1].substring(0, e[t][1].length - e[t - 1][1].length), e[t + 1][1] = e[t - 1][1] + e[t + 1][1], e.splice(t - 1, 1), l = !0) : e[t][1].substring(0, e[t + 1][1].length) == e[t + 1][1] && (e[t - 1][1] += e[t + 1][1], e[t][1] = e[t][1].substring(e[t + 1][1].length) + e[t + 1][1], e.splice(t + 1, 1), l = !0)), t++;
    l && this.diff_cleanupMerge(e);
  }, s.prototype.diff_xIndex = function(e, t) {
    var n = 0, a = 0, i = 0, r = 0, o;
    for (o = 0; o < e.length && (e[o][0] !== g && (n += e[o][1].length), e[o][0] !== c && (a += e[o][1].length), !(n > t)); o++)
      i = n, r = a;
    return e.length != o && e[o][0] === c ? r : r + (t - i);
  }, s.prototype.diff_prettyHtml = function(e) {
    for (var t = [], n = /&/g, a = /</g, i = />/g, r = /\n/g, o = 0; o < e.length; o++) {
      var l = e[o][0], u = e[o][1], f = u.replace(n, "&amp;").replace(a, "&lt;").replace(i, "&gt;").replace(r, "&para;<br>");
      switch (l) {
        case g:
          t[o] = '<ins style="background:#e6ffe6;">' + f + "</ins>";
          break;
        case c:
          t[o] = '<del style="background:#ffe6e6;">' + f + "</del>";
          break;
        case p:
          t[o] = "<span>" + f + "</span>";
          break;
      }
    }
    return t.join("");
  }, s.prototype.diff_text1 = function(e) {
    for (var t = [], n = 0; n < e.length; n++)
      e[n][0] !== g && (t[n] = e[n][1]);
    return t.join("");
  }, s.prototype.diff_text2 = function(e) {
    for (var t = [], n = 0; n < e.length; n++)
      e[n][0] !== c && (t[n] = e[n][1]);
    return t.join("");
  }, s.prototype.diff_levenshtein = function(e) {
    for (var t = 0, n = 0, a = 0, i = 0; i < e.length; i++) {
      var r = e[i][0], o = e[i][1];
      switch (r) {
        case g:
          n += o.length;
          break;
        case c:
          a += o.length;
          break;
        case p:
          t += Math.max(n, a), n = 0, a = 0;
          break;
      }
    }
    return t += Math.max(n, a), t;
  }, s.prototype.diff_toDelta = function(e) {
    for (var t = [], n = 0; n < e.length; n++)
      switch (e[n][0]) {
        case g:
          t[n] = "+" + encodeURI(e[n][1]);
          break;
        case c:
          t[n] = "-" + e[n][1].length;
          break;
        case p:
          t[n] = "=" + e[n][1].length;
          break;
      }
    return t.join("	").replace(/%20/g, " ");
  }, s.prototype.diff_fromDelta = function(e, t) {
    for (var n = [], a = 0, i = 0, r = t.split(/\t/g), o = 0; o < r.length; o++) {
      var l = r[o].substring(1);
      switch (r[o].charAt(0)) {
        case "+":
          try {
            n[a++] = new s.Diff(g, decodeURI(l));
          } catch {
            throw new Error("Illegal escape in diff_fromDelta: " + l);
          }
          break;
        case "-":
        case "=":
          var u = parseInt(l, 10);
          if (isNaN(u) || u < 0)
            throw new Error("Invalid number in diff_fromDelta: " + l);
          var f = e.substring(i, i += u);
          r[o].charAt(0) == "=" ? n[a++] = new s.Diff(p, f) : n[a++] = new s.Diff(c, f);
          break;
        default:
          if (r[o])
            throw new Error("Invalid diff operation in diff_fromDelta: " + r[o]);
      }
    }
    if (i != e.length)
      throw new Error("Delta length (" + i + ") does not equal source text length (" + e.length + ").");
    return n;
  }, s.prototype.match_main = function(e, t, n) {
    if (e == null || t == null || n == null)
      throw new Error("Null input. (match_main)");
    return n = Math.max(0, Math.min(n, e.length)), e == t ? 0 : e.length ? e.substring(n, n + t.length) == t ? n : this.match_bitap_(e, t, n) : -1;
  }, s.prototype.match_bitap_ = function(e, t, n) {
    if (t.length > this.Match_MaxBits)
      throw new Error("Pattern too long for this browser.");
    var a = this.match_alphabet_(t), i = this;
    function r(A, V) {
      var P = A / t.length, R = Math.abs(n - V);
      return i.Match_Distance ? P + R / i.Match_Distance : R ? 1 : P;
    }
    var o = this.Match_Threshold, l = e.indexOf(t, n);
    l != -1 && (o = Math.min(r(0, l), o), l = e.lastIndexOf(t, n + t.length), l != -1 && (o = Math.min(r(0, l), o)));
    var u = 1 << t.length - 1;
    l = -1;
    for (var f, h, v = t.length + e.length, m, _ = 0; _ < t.length; _++) {
      for (f = 0, h = v; f < h; )
        r(_, n + h) <= o ? f = h : v = h, h = Math.floor((v - f) / 2 + f);
      v = h;
      var j = Math.max(1, n - h + 1), T = Math.min(n + h, e.length) + t.length, O = Array(T + 2);
      O[T + 1] = (1 << _) - 1;
      for (var k = T; k >= j; k--) {
        var C = a[e.charAt(k - 1)];
        if (_ === 0 ? O[k] = (O[k + 1] << 1 | 1) & C : O[k] = (O[k + 1] << 1 | 1) & C | ((m[k + 1] | m[k]) << 1 | 1) | m[k + 1], O[k] & u) {
          var N = r(_, k - 1);
          if (N <= o)
            if (o = N, l = k - 1, l > n)
              j = Math.max(1, 2 * n - l);
            else
              break;
        }
      }
      if (r(_ + 1, n) > o)
        break;
      m = O;
    }
    return l;
  }, s.prototype.match_alphabet_ = function(e) {
    for (var t = {}, n = 0; n < e.length; n++)
      t[e.charAt(n)] = 0;
    for (var n = 0; n < e.length; n++)
      t[e.charAt(n)] |= 1 << e.length - n - 1;
    return t;
  }, s.prototype.patch_addContext_ = function(e, t) {
    if (t.length != 0) {
      if (e.start2 === null)
        throw Error("patch not initialized");
      for (var n = t.substring(e.start2, e.start2 + e.length1), a = 0; t.indexOf(n) != t.lastIndexOf(n) && n.length < this.Match_MaxBits - this.Patch_Margin - this.Patch_Margin; )
        a += this.Patch_Margin, n = t.substring(
          e.start2 - a,
          e.start2 + e.length1 + a
        );
      a += this.Patch_Margin;
      var i = t.substring(e.start2 - a, e.start2);
      i && e.diffs.unshift(new s.Diff(p, i));
      var r = t.substring(
        e.start2 + e.length1,
        e.start2 + e.length1 + a
      );
      r && e.diffs.push(new s.Diff(p, r)), e.start1 -= i.length, e.start2 -= i.length, e.length1 += i.length + r.length, e.length2 += i.length + r.length;
    }
  }, s.prototype.patch_make = function(e, t, n) {
    var a, i;
    if (typeof e == "string" && typeof t == "string" && typeof n > "u")
      a = /** @type {string} */
      e, i = this.diff_main(
        a,
        /** @type {string} */
        t,
        !0
      ), i.length > 2 && (this.diff_cleanupSemantic(i), this.diff_cleanupEfficiency(i));
    else if (e && typeof e == "object" && typeof t > "u" && typeof n > "u")
      i = /** @type {!Array.<!diff_match_patch.Diff>} */
      e, a = this.diff_text1(i);
    else if (typeof e == "string" && t && typeof t == "object" && typeof n > "u")
      a = /** @type {string} */
      e, i = /** @type {!Array.<!diff_match_patch.Diff>} */
      t;
    else if (typeof e == "string" && typeof t == "string" && n && typeof n == "object")
      a = /** @type {string} */
      e, i = /** @type {!Array.<!diff_match_patch.Diff>} */
      n;
    else
      throw new Error("Unknown call format to patch_make.");
    if (i.length === 0)
      return [];
    for (var r = [], o = new s.patch_obj(), l = 0, u = 0, f = 0, h = a, v = a, m = 0; m < i.length; m++) {
      var _ = i[m][0], j = i[m][1];
      switch (!l && _ !== p && (o.start1 = u, o.start2 = f), _) {
        case g:
          o.diffs[l++] = i[m], o.length2 += j.length, v = v.substring(0, f) + j + v.substring(f);
          break;
        case c:
          o.length1 += j.length, o.diffs[l++] = i[m], v = v.substring(0, f) + v.substring(f + j.length);
          break;
        case p:
          j.length <= 2 * this.Patch_Margin && l && i.length != m + 1 ? (o.diffs[l++] = i[m], o.length1 += j.length, o.length2 += j.length) : j.length >= 2 * this.Patch_Margin && l && (this.patch_addContext_(o, h), r.push(o), o = new s.patch_obj(), l = 0, h = v, u = f);
          break;
      }
      _ !== g && (u += j.length), _ !== c && (f += j.length);
    }
    return l && (this.patch_addContext_(o, h), r.push(o)), r;
  }, s.prototype.patch_deepCopy = function(e) {
    for (var t = [], n = 0; n < e.length; n++) {
      var a = e[n], i = new s.patch_obj();
      i.diffs = [];
      for (var r = 0; r < a.diffs.length; r++)
        i.diffs[r] = new s.Diff(a.diffs[r][0], a.diffs[r][1]);
      i.start1 = a.start1, i.start2 = a.start2, i.length1 = a.length1, i.length2 = a.length2, t[n] = i;
    }
    return t;
  }, s.prototype.patch_apply = function(e, t) {
    if (e.length == 0)
      return [t, []];
    e = this.patch_deepCopy(e);
    var n = this.patch_addPadding(e);
    t = n + t + n, this.patch_splitMax(e);
    for (var a = 0, i = [], r = 0; r < e.length; r++) {
      var o = e[r].start2 + a, l = this.diff_text1(e[r].diffs), u, f = -1;
      if (l.length > this.Match_MaxBits ? (u = this.match_main(
        t,
        l.substring(0, this.Match_MaxBits),
        o
      ), u != -1 && (f = this.match_main(
        t,
        l.substring(l.length - this.Match_MaxBits),
        o + l.length - this.Match_MaxBits
      ), (f == -1 || u >= f) && (u = -1))) : u = this.match_main(t, l, o), u == -1)
        i[r] = !1, a -= e[r].length2 - e[r].length1;
      else {
        i[r] = !0, a = u - o;
        var h;
        if (f == -1 ? h = t.substring(u, u + l.length) : h = t.substring(u, f + this.Match_MaxBits), l == h)
          t = t.substring(0, u) + this.diff_text2(e[r].diffs) + t.substring(u + l.length);
        else {
          var v = this.diff_main(l, h, !1);
          if (l.length > this.Match_MaxBits && this.diff_levenshtein(v) / l.length > this.Patch_DeleteThreshold)
            i[r] = !1;
          else {
            this.diff_cleanupSemanticLossless(v);
            for (var m = 0, _, j = 0; j < e[r].diffs.length; j++) {
              var T = e[r].diffs[j];
              T[0] !== p && (_ = this.diff_xIndex(v, m)), T[0] === g ? t = t.substring(0, u + _) + T[1] + t.substring(u + _) : T[0] === c && (t = t.substring(0, u + _) + t.substring(u + this.diff_xIndex(
                v,
                m + T[1].length
              ))), T[0] !== c && (m += T[1].length);
            }
          }
        }
      }
    }
    return t = t.substring(n.length, t.length - n.length), [t, i];
  }, s.prototype.patch_addPadding = function(e) {
    for (var t = this.Patch_Margin, n = "", a = 1; a <= t; a++)
      n += String.fromCharCode(a);
    for (var a = 0; a < e.length; a++)
      e[a].start1 += t, e[a].start2 += t;
    var i = e[0], r = i.diffs;
    if (r.length == 0 || r[0][0] != p)
      r.unshift(new s.Diff(p, n)), i.start1 -= t, i.start2 -= t, i.length1 += t, i.length2 += t;
    else if (t > r[0][1].length) {
      var o = t - r[0][1].length;
      r[0][1] = n.substring(r[0][1].length) + r[0][1], i.start1 -= o, i.start2 -= o, i.length1 += o, i.length2 += o;
    }
    if (i = e[e.length - 1], r = i.diffs, r.length == 0 || r[r.length - 1][0] != p)
      r.push(new s.Diff(p, n)), i.length1 += t, i.length2 += t;
    else if (t > r[r.length - 1][1].length) {
      var o = t - r[r.length - 1][1].length;
      r[r.length - 1][1] += n.substring(0, o), i.length1 += o, i.length2 += o;
    }
    return n;
  }, s.prototype.patch_splitMax = function(e) {
    for (var t = this.Match_MaxBits, n = 0; n < e.length; n++)
      if (!(e[n].length1 <= t)) {
        var a = e[n];
        e.splice(n--, 1);
        for (var i = a.start1, r = a.start2, o = ""; a.diffs.length !== 0; ) {
          var l = new s.patch_obj(), u = !0;
          for (l.start1 = i - o.length, l.start2 = r - o.length, o !== "" && (l.length1 = l.length2 = o.length, l.diffs.push(new s.Diff(p, o))); a.diffs.length !== 0 && l.length1 < t - this.Patch_Margin; ) {
            var f = a.diffs[0][0], h = a.diffs[0][1];
            f === g ? (l.length2 += h.length, r += h.length, l.diffs.push(a.diffs.shift()), u = !1) : f === c && l.diffs.length == 1 && l.diffs[0][0] == p && h.length > 2 * t ? (l.length1 += h.length, i += h.length, u = !1, l.diffs.push(new s.Diff(f, h)), a.diffs.shift()) : (h = h.substring(
              0,
              t - l.length1 - this.Patch_Margin
            ), l.length1 += h.length, i += h.length, f === p ? (l.length2 += h.length, r += h.length) : u = !1, l.diffs.push(new s.Diff(f, h)), h == a.diffs[0][1] ? a.diffs.shift() : a.diffs[0][1] = a.diffs[0][1].substring(h.length));
          }
          o = this.diff_text2(l.diffs), o = o.substring(o.length - this.Patch_Margin);
          var v = this.diff_text1(a.diffs).substring(0, this.Patch_Margin);
          v !== "" && (l.length1 += v.length, l.length2 += v.length, l.diffs.length !== 0 && l.diffs[l.diffs.length - 1][0] === p ? l.diffs[l.diffs.length - 1][1] += v : l.diffs.push(new s.Diff(p, v))), u || e.splice(++n, 0, l);
        }
      }
  }, s.prototype.patch_toText = function(e) {
    for (var t = [], n = 0; n < e.length; n++)
      t[n] = e[n];
    return t.join("");
  }, s.prototype.patch_fromText = function(e) {
    var t = [];
    if (!e)
      return t;
    for (var n = e.split(`
`), a = 0, i = /^@@ -(\d+),?(\d*) \+(\d+),?(\d*) @@$/; a < n.length; ) {
      var r = n[a].match(i);
      if (!r)
        throw new Error("Invalid patch string: " + n[a]);
      var o = new s.patch_obj();
      for (t.push(o), o.start1 = parseInt(r[1], 10), r[2] === "" ? (o.start1--, o.length1 = 1) : r[2] == "0" ? o.length1 = 0 : (o.start1--, o.length1 = parseInt(r[2], 10)), o.start2 = parseInt(r[3], 10), r[4] === "" ? (o.start2--, o.length2 = 1) : r[4] == "0" ? o.length2 = 0 : (o.start2--, o.length2 = parseInt(r[4], 10)), a++; a < n.length; ) {
        var l = n[a].charAt(0);
        try {
          var u = decodeURI(n[a].substring(1));
        } catch {
          throw new Error("Illegal escape in patch_fromText: " + u);
        }
        if (l == "-")
          o.diffs.push(new s.Diff(c, u));
        else if (l == "+")
          o.diffs.push(new s.Diff(g, u));
        else if (l == " ")
          o.diffs.push(new s.Diff(p, u));
        else {
          if (l == "@")
            break;
          if (l !== "")
            throw new Error('Invalid patch mode "' + l + '" in: ' + u);
        }
        a++;
      }
    }
    return t;
  }, s.patch_obj = function() {
    this.diffs = [], this.start1 = null, this.start2 = null, this.length1 = 0, this.length2 = 0;
  }, s.patch_obj.prototype.toString = function() {
    var e, t;
    this.length1 === 0 ? e = this.start1 + ",0" : this.length1 == 1 ? e = this.start1 + 1 : e = this.start1 + 1 + "," + this.length1, this.length2 === 0 ? t = this.start2 + ",0" : this.length2 == 1 ? t = this.start2 + 1 : t = this.start2 + 1 + "," + this.length2;
    for (var n = ["@@ -" + e + " +" + t + ` @@
`], a, i = 0; i < this.diffs.length; i++) {
      switch (this.diffs[i][0]) {
        case g:
          a = "+";
          break;
        case c:
          a = "-";
          break;
        case p:
          a = " ";
          break;
      }
      n[i + 1] = a + encodeURI(this.diffs[i][1]) + `
`;
    }
    return n.join("").replace(/%20/g, " ");
  }, d.exports = s, d.exports.diff_match_patch = s, d.exports.DIFF_DELETE = c, d.exports.DIFF_INSERT = g, d.exports.DIFF_EQUAL = p;
})(le);
var Se = le.exports;
const ke = { class: "vue3-json-diff" }, Ce = { class: "item" }, De = { class: "item" }, Ae = ["innerHTML"], Ne = { class: "item" }, Re = /* @__PURE__ */ me({
  __name: "Vue3JsonDiff",
  props: {
    leftValue: {
      type: null,
      required: !0
    },
    rightValue: {
      type: null,
      required: !0
    }
  },
  setup(d) {
    const s = d, c = ye(() => {
      const g = new Se.diff_match_patch(), p = JSON.stringify(s.leftValue), e = JSON.stringify(s.rightValue);
      console.log("计算区别", p, e);
      const t = g.diff_main(
        p,
        e
      );
      return console.log("区别: ", t), g.diff_prettyHtml(
        t
      );
    });
    return (g, p) => (J(), U("div", ke, [
      z("div", Ce, [
        Q(W(K), {
          value: s.leftValue
        }, null, 8, ["value"])
      ]),
      z("div", De, [
        z("div", { innerHTML: c.value }, null, 8, Ae)
      ]),
      z("div", Ne, [
        Q(W(K), {
          value: s.rightValue
        }, null, 8, ["value"])
      ])
    ]));
  }
});
const Oe = (d, s) => {
  const c = d.__vccOpts || d;
  for (const [g, p] of s)
    c[g] = p;
  return c;
}, Ie = /* @__PURE__ */ Oe(Re, [["__scopeId", "data-v-bdd0a244"]]);
export {
  Ie as default
};
